1000	%title "source_code_manager_xxx.bas"
	option type=explicit
	%ident                            "version_102.3"			! <<<---***
	declare string constant k_version	= "102.3"
	declare string constant k_program = "OpenVMS-BASIC-Source-Code-Manager"	!
	!==============================================================================================================
	! title  : source_code_manager_xxx.bas
	! author : Neil Rieck (http://www3.sympatico.ca/n.rieck/)
	! notes  : this was a quick hack and is in need of a major rewrite
	!        : this program has no comercial value and has been put into public domain for educational use only
	! history:
	! ver who when   what
	! --- --- ------ ----------------------------------------------------------------------------------------------
	! 100 NSR 040507 1. original program (portions from SOURCE_CODE_REPORTER_101.BAS)
	!     NSR 040510 2. added a "purge required" sanity test
	!     NSR 040511 3. finished the mover logic
	!     NSR 040521 4. tweaked the mover logic
	! 101 NSR 040522 1. rewrote the cos detector
	!		 2. added a sequence hole detector
	!		 3. added a file sort (to take care of situations where '_10' comes before '_9')
	! 102 NSR 040524 1. now do a more restrictive directory command
	!		 2. now call $sort  ((to take care of situations where '_10' comes before '_9')
	!     NSR 041211 3. changed program name (replaced Compaq with OpenVMS)
	!==============================================================================================================
	set no prompt								! no kid stuff
	!
	%include "lib$routines" %from %library "sys$library:basic$starlet"	! for lib$spawn etc.
	!
	external string function wcsm_dt_stamp					!
	!
	declare string constant htab	= '9'C 					! horizontal TAB
	declare	string	fs1$			,				! file spec1					&
			ver$			,				!						&
			frag$			,				!						&
			junk$			,				!						&
			pseudo$			,				!						&
			swap$			,				!						&
			temp$			,				!						&
			dvlp_min$		,				!						&
			src_min$		,				!						&
			filter$			,				!						&
			cmd$			,				! DCL command					&
			loaded_frag$		,				!						&
		long	i%			,				!						&
			j%			,				!						&
			hole_count%		,				!						&
			line_count%		,				!						&
			loaded_count%		,				!						&
			loaded_version%		,				!						&
			dvlp_min%		,				!						&
			src_min%		,				!						&
			junk%			,				!						&
			cos%			,				!						&
			swap_flag%		,				!						&
			handler_error%		,				!						&
			temp%			,				!						&
			ver%			,				!						&
			cmd_file_open%		,				!						&
			us_pos%			,				!						&
			dot_pos%		,				!						&
			semi_pos%		,				!						&
			comments_start%		,				!						&
			insert%			,				!						&
			in_range%		,				!						&
			rc%			,				!						&
			count%			,				!						&
			idate8a%		,				! icsis date-a (8 digits)			&
			idate8b%		,				! icsis date-b (8 digits)			&
			debug_flag%						!
	!
	declare long constant k_lines%  = 1000					! number of comment lines per program
	dim string fs$  (k_lines%)						!
	dim long   ver% (k_lines%)						!
	dim string frag$(k_lines%)						!
	!
	!====================================================================================================
	!	<<< main >>>
	!====================================================================================================
	junk$ = k_program + " v" + k_version
	print string$( len(junk$), ascii("=") )
	print junk$								! print program title
	print string$( len(junk$), ascii("=") )
	input "show help now? (default=N) "; junk$
	junk$ = edit$(junk$,32+4+2)						! upcase, no controls, no white space
	if left$(junk$,1)="Y" then
	    !      12345678901234567890123456789012345678901234567890123456789012345678901234567890
	    print
	    print "  1.  this program will scan the current directory for BASIC sources."
	    print "  2.  it will compare file names and make sure that there is only a limited"
	    print "      number of versions present (these are numbers embedded in the file name,"
	    print "      not VMS version numbers)"
	    print "  3.  excess numbers of old versions found in directory CSMIS$DVLP will be"
	    print "      moved to CSMIS$SRC"
	    print "  4.  excess numbers of old versions found in directory CSMIS$SRC will be"
	    print "      moved to CSMIS$ARCHIVE"
	    print
	end if
	!
	input "debug level? (0-2, default=0) "; junk$
	when error in
	    debug_flag% = integer(junk$)
	use
	    debug_flag% = 0
	end when
	debug_flag% = 0 if debug_flag% < 0
	!
	print "minimum number of files in CSMIS$DVLP ? (min=1, default=2) ";
	input dvlp_min$
	when error in
	    dvlp_min% = integer(dvlp_min$)
	use
	    dvlp_min% = 0
	end when
	select dvlp_min%
	    case < 1
		dvlp_min% = 2							! default = 2
	end select
	!
	print "minimum number of files in CSMIS$SRC  ? (min=1, default=3) ";
	input src_min$
	when error in
	    src_min% = integer(src_min$)
	use
	    src_min% = 0
	end when
	select src_min%
	    case < 1
		src_min% = 3							! default = 3
	end select
	!
	print "file directory build:"
	input "enter first letter(s) of BASIC source file? (default=all) ";filter$
	print
	filter$ = edit$(filter$,32+4+2)						! upcase, no controls, no white space
	if filter$ = "" then
	    filter$ = "*"
	else
	    if pos(filter$,"*",1)=0 then					! if no asterisk was provided...
		filter$ = filter$ +"*"						! ...then add one
	    end if
	end if
	!
	!	build a directory (of basic files with an underscore in the name)
	!
	cmd$ = "$dir/nohead/notrail "+ filter$ +"*_*.BAS"			! get a directory of BASIC files	&
		+"/out="+ k_program +".scratch"
	rc% = lib$spawn(cmd$)							! let DCL execute this command
	print cmd$
	if ((rc% and 7%) <> 1%) then
	    print "-e- lib$spawn error: "+ str$(rc%)
	    goto sortie
	end if
	!
	!	now read the directory listing file (to see if we've found any files to process)
	!
	when error in
	    open k_program +".scratch" for input as #1, recordsize 1024		! open file list
	    count% = 0
	    while 1
		linput #1, junk$						! display the listed file names
		count% = count% + 1
		print #3, format$(count%,"#### ")+junk$
	    next
	use
	end when
	if count% = 0 then
	    print "-e- no files were detected using your search criteria"
	    goto sortie
	end if
	!
	!	now read the directory listing file (again, to dump the filenames into an output file)
	!
	when error in
	    open k_program +".temp" for output as #3, recordsize 1024		! open output file
	    reset #1								! BOF
	    count% = 0
	    while 1
		!
		!	eg.	yada_100.bas;1
		!
		linput #1, fs1$							! read a file name
		!
		!	locate the last dot
		!
		dot_pos% = 0							! init
		junk% = 1							!
		while junk% <> 0						!
		    junk% = pos(fs1$, ".", junk%+1)				!
		    dot_pos% = junk% if junk% > 0				!
		next								!
		!
		!	locate the last semi colon
		!
		semi_pos% = 0							! init
		junk% = 1							!
		while junk% <> 0						!
		    junk% = pos(fs1$, ";", junk%+1)				!
		    semi_pos% = junk% if junk% > 0				!
		next								!
		!
		!	locate the last underscore before the last dot (beware cuz these could exist in the file extension)
		!
		us_pos% = 0							! init
		junk% = 1							!
		while junk% <> 0						!
		    junk% = pos(fs1$, "_", junk%+1)				!
		    us_pos% = junk% if junk% < dot_pos% and junk% <> 0%		!
		next								!
		!
		!	reject this record if anything looks weird
		!
		if dot_pos% = 0 or us_pos% = 0 or semi_pos% = 0 then
		    if debug_flag% >= 1 then
			print "-w-insuf-punct, ignoring ";fs1$
			print "-i-debug-dot: ";str$(dot_pos%);" us: ";str$(us_pos%);" semi: ";str$(semi_pos%)
		    end if
		    iterate
		end if
		!
		when error in
		    temp$ = seg$(fs1$, us_pos%+1, dot_pos%-1)
		    ver% = integer(temp$)
		use
		    ver% = 0
		end when
		if ver% = 0 then
		    print "-w-no-version, ignoring ";fs1$	if debug_flag% >= 1
		    iterate
		end if
		!
		count% = count% + 1
		print "-i-pass, saving ";fs1$	if debug_flag% >= 2
		!
		!	create a pseudo name which will be used in a pre-sort
		!
		!		dir sort	after pre-sort
		!
		!	eg.	yada_100	yada_00000000000097
		!		yada_97		yada_00000000000098
		!		yada_98		yada_00000000000099
		!		yada_99		yada_00000000000100
		!
		pseudo$ = left$(fs1$,us_pos%-1) +"_"+ format$(ver%, "<0>#############")
		print #3, pseudo$			+","+			! pseudo name for pre-sort		&
			  left$(fs1$,semi_pos%-1)	+","+			! fs1$ without a VMS version number	&
			  temp$				+","+			! version				&
			  left$(fs1$,us_pos%-1)					! name-stub 
	    next
	use
	end when
	close #1, #3
	!
	!	call $sort to put everything in pseudo-name order
	!	
	if count% >= 2 then							!
		cmd$ = "$sort "+ k_program +".temp *.*"
		rc% = lib$spawn(cmd$)						! let DCL execute this command
		print cmd$
		if ((rc% and 7%) <> 1%) then
		    print "-e- lib$spawn error: "+ str$(rc%)
		    goto sortie
		end if
	end if
	!
	!	now read the directory listing file (again, to process the associated file's contents)
	!
	when error in
	    open k_program +".temp" for input as #3, recordsize 1024		!
	    loaded_frag$	= ""						! init
	    loaded_count%	= 0						! init
	    line_count%		= 0						!
	    while 1
		input #3, pseudo$, fs1$, ver$, frag$				! read record: pseudo, file-spec, version, and stub
		line_count% = line_count% + 1					! advance the line counter
		print "-i-debug: "+ fs1$, ver$, frag$	if debug_flag% >= 2
		ver% = integer(ver$)						! get version number for sequential version test
		!
		!	don't allow multiple versions of the same VMS file
		!
		if (loaded_frag$ = frag$)		and			! if same name					&
		   (loaded_version% = ver%)					! and same version
		then
		    print bel;
		    print "********************************************************************"
		    print "-e- DANGER: you must purge this directory before running this tool."
		    print "    This program will now exit"
		    print "********************************************************************"
		    sleep 1
		    goto sortie
		end if
		!
		!	load file data into an array (for comparison purposes)
		!
		cos% = 0							! init cos flag
		if line_count% > 1 then						! if not the first time thru
		    if loaded_frag$ = frag$	and				! if same fragment...				&
!~~~		       (loaded_version% + 1) <> ver%				x ...but unexpected sequence			&
		       abs(loaded_version% - ver%) <> 1				! ...but unexpected sequence
		    then
			cos% = 1						!
			!
			!	alert the operator of detected holes in program sequences
			!	eg.	yada_100.bas
			!		yada_102.bas	(where is yada_101.bas ???)
			!
			!	eg.	however, beware of this sort anomaly which is legal:
			!
			!		yada_10.bas
			!		yada_9.bas
			!
			print "************************************************************"
			print "-w- sequence hole for program: ";frag$
			print "    from: ";str$(loaded_version%);" to: ";str$(ver%)
			print "************************************************************"
			input "hit <enter> to continue..."; junk$
			hole_count% = hole_count% + 1
		    end if
		    cos% = 2 if loaded_frag$ <> frag$				! if different fragment
		end if
		!
		if cos% = 0							!
		then								! ...just store the data
		    loaded_frag$	= frag$					! remember new fragment
		    loaded_version%	= ver%					! remember new version 
		    print "-i- storing addtional file data ";frag$;" ";ver$;" ";fs1$	if debug_flag% >= 2
		    loaded_count%	= loaded_count% + 1			! prep for array store operation
		    fs$  (loaded_count%) = fs1$					!
		    frag$(loaded_count%) = frag$				!
		    ver% (loaded_count%) = ver%					!
		else								! ...something changed
		    print "-i- detected COS; calling mover"	if debug_flag% >= 2
		    gosub mover							! process data stored in our array
		    !
		    !	now store the file data that triggered a C-O-S
		    !
		    print "-i- storing NEW file data ";frag$;" ";ver$;" ";fs1$	if debug_flag% >= 2
		    loaded_frag$ = frag$					! just store the data
		    loaded_version% = ver%					!
		    loaded_count% = 1						! init
		    fs$  (loaded_count%) = fs1$					!
		    frag$(loaded_count%) = frag$				!
		    ver% (loaded_count%) = ver%					!
		end if
	    next
	use
	    handler_error% = err
	end when
	!
	if handler_error% = 11 then						! handle the last case
		print "-i- detected EOF; calling mover"	if debug_flag% >= 2
		gosub mover
	end if
	!
	close 1,2,3
	if cmd_file_open% = 1 then
	    if hole_count% > 0 then
		print "-w- total sequence holes: ";str$(hole_count%)
	    end if
	    input "Execute the command file? (Y/N, default=N) ";junk$
	    junk$ = edit$(junk$,32+2)
	    select left$(junk$,1)
	        case "Y"
		    junk% = lib$spawn("@"+ k_program +".cmd")
		case else
		    print "-i- command file was NOT executed"
	    end select
	else
	    print "-i- no file was found that should be moved"
	end if
	goto sortie								! that's all folks	***--->>>
	!
	!	<<< selectively move the file >>>
	!
	mover:
	    !
	    !	now move lower numbers of program sequences
	    !
	    goto skip_operation if loaded_count% <= 1				! jump if not enough to consider
	    !
	    !	because of a sort anomaly we may see the following order:
	    !		yada_10.bas
	    !		yada_9.bas
	    !	so now would be a good time to sort the array
	    !
	    sort:
	    swap_flag% = 0
	    for i% = 1 to (loaded_count%-1)					!
		if ver%(i%) > ver%(i%+1) then					! if first item is greater than second
		    junk%       = ver%(i%)					! swap ver$()
		    ver%(i%)	= ver%(i%+1)					!
		    ver%(i%+1)	= junk%						!
		    swap$	= fs$(i%)					! swap fs$()
		    fs$(i%)	= fs$(i%+1)					!
		    fs$(i%+1)	= swap$						!
		    swap_flag%	= 1						! indicate a swap has occurred
		end if
	    next i%
	    goto sort if swap_flag% = 1						! loop until bubble sort is complete
	    !
	    if pos(fs$(1),"[DVLP]",1) > 0 then					! if in the development directory
		goto skip_operation if loaded_count% <= dvlp_min%		! jump if not enough loaded
		!
		! note: let's say we've loaded 10 sequential programs but the minimum is set to 2,
		!	this stub will move programs 1-7
		!
		for i% = 1 to (loaded_count%-dvlp_min%)				!
		    junk$ = "$ren "+ fs$(i%) +" CSMIS$SRC:/log"
		    gosub build_cmd
		next i%
	    end if
	    !
	    if pos(fs$(1),"[SRC]",1) > 0 then					! if in the source directory
		goto skip_operation if loaded_count% <= src_min%		! jump if not enough loaded
		!
		! note: let's say we've loaded 10 sequential programs but the minimum is set to 2,
		!	this stub will move programs 1-7
		!
		for i% = 1 to (loaded_count%-src_min%)				!
		    junk$ = "$ren "+ fs$(i%) +" CSMIS$ARCHIVE:/log"		!
		    gosub build_cmd
		next i%
	    end if
	    !	
	    skip_operation:						!
	return
	!
	!	build command line
	!
	build_cmd:
	if cmd_file_open% = 0 then
	    open k_program +".cmd" for output as #2, recordsize 1024
	    print #2, "$set on"
	    print #2, "$on error then exit"
	    cmd_file_open% = 1
	end if
	print #2, junk$
	print junk$
	return
	!
	!	<<< adios >>>
	!
30000	sortie:
	close 1,2,3
	goto exit_now	if debug_flag% > 0
	!
	print "-i- deleting temp files created by this program"
	when error in
	    while 1
		kill k_program+".cmd"
	    next
	use
	end when
	!
	when error in
	    while 1
		kill k_program+".scratch"
	    next
	use
	end when
	!
	when error in
	    while 1
		kill k_program+".temp"
	    next
	use
	end when
	!
	exit_now:
	print "-i- adios"
	!
	end
	!====================================================================================================
	!
	!	external functions
	!
31000	%include "[.fun]wcsm_dt_stamp.fun"
	!
