1000	%title "source_code_reporter_xxx.bas"
	option type=explicit
	%ident                            "version_100.6"			! <<<---***
	declare string constant k_version	= "100.6"
	declare string constant k_program = "OpenVMS-BASIC-Source-Code-Reporter"
	!==============================================================================================================
	! title  : source_code_reporter_xxx.bas
	! author : Neil Rieck (http://www3.sympatico.ca/n.rieck/)
	! notes  : this was a quick hack and is in need of a major rewrite
	!        : this program has no comercial value and has been put into public domain for educational use only
	! history:
	! ver who when   what
	! --- --- ------ ----------------------------------------------------------------------------------------------
	! 100 NSR 040208 1. original program (portions from SOURCE_CODE_FORMATTER_101.BAS)
	!     NSR 040209 2. added a debug switch
	!		 3. dropped the "/before" parameter
	!     NSR 040210 4. added support for 8 character date stamps (see VDSL_TVGUIDE_111.bas)
	!     NSR 040506 5. fixed a bug in the date comparision logic					bf_100.5
	!     NSR 041211 6. changed program name (replaced Compaq with OpenVMS)
	!==============================================================================================================
	set no prompt								! no kid stuff
	!
	%include "lib$routines" %from %library "sys$library:basic$starlet"	! for lib$spawn etc.
	!
	external string function icsis_date_to_vms_date(string)			!
	external string function wcsm_dt_stamp					!
	!
	declare string constant htab	= '9'C 					! horizontal TAB
	declare	string	fs1$			,				! file spec1					&
			fs2$			,				! file spec2					&
			ip$			,				!						&
			junk$			,				!						&
			filter$			,				!						&
			idate6a$		,				! icsis date-a (6 char)				&
			vdate1$			,				! vms date #1					&
			idate6b$		,				! icsis date-b (6 char)				&
			vdate2$			,				! vms date #2					&
			cmd$			,				! DCL command					&
			junk_word$		,				!						&
		long	i%			,				!						&
			j%			,				!						&
			junk%			,				!						&
			comments_start%		,				!						&
			insert%			,				!						&
			in_range%		,				!						&
			rc%			,				!						&
			count%			,				!						&
			idate8a%		,				! icsis date-a (8 digits)			&
			idate8b%		,				! icsis date-b (8 digits)			&
			debug_flag%						!
	!
	declare long constant k_lines%  = 1000					! number of comment lines per program
	dim string lines$(k_lines%)						!
	!
	!====================================================================================================
	!	<<< main >>>
	!====================================================================================================
	junk$ = k_program + " v" + k_version
	print string$( len(junk$), ascii("=") )
	print junk$								! print program title
	print string$( len(junk$), ascii("=") )
	input "show help now? (default=N) "; junk$
	junk$ = edit$(junk$,32+4+2)						! upcase, no controls, no white space
	if left$(junk$,1)="Y" then
	    !      12345678901234567890123456789012345678901234567890123456789012345678901234567890
	    print "tips:"
	    print "  1.  this program will scan the comments area of selected BASIC source files"
	    print "  2.  dates in comments should look like this 031231"
	    print
	end if
	!
	input "debug? (Y/N, default=N) "; junk$
	select left$(edit$(junk$,32+2),1)
	    case "Y"
		debug_flag% = 1
	    case else
		debug_flag% = 0
	end select
	!
	print "file directory build:"
	input "enter first letter(s) of BASIC source file? (default=all) ";filter$
	print
	filter$ = edit$(filter$,32+4+2)						! upcase, no controls, no white space
	if filter$ = "" then
	    filter$ = "*"
	else
	    if pos(filter$,"*",1)=0 then					! if no asterisk was provided...
		filter$ = filter$ +"*"						! ...then add one
	    end if
	end if
	!
	get_dates:
	input "starting date? (eg. yymmdd, default=quit) "; idate6a$
	goto sortie if idate6a$ = ""
	vdate1$ = icsis_date_to_vms_date(idate6a$)
	goto get_dates if vdate1$ = ""
	!
	input "ending date  ? (eg. yymmdd, default=quit) "; idate6b$
	goto sortie if idate6b$ = ""
	vdate2$ = icsis_date_to_vms_date(idate6b$)
	goto get_dates if vdate2$ = ""
	!
	if idate6a$ > idate6b$ then
	    print "-e- first date is after second date"
	    goto get_dates
	else
	    when error in
		idate8a% = integer(idate6a$)
		select idate8a%
		    case >= 910101
			idate8a% = idate8a% + 19000000
		    case else
			idate8a% = idate8a% + 20000000
		end select
		!
		idate8b% = integer(idate6b$)
		select idate8b%
		    case >= 910101
			idate8b% = idate8b% + 19000000
		    case else
			idate8b% = idate8b% + 20000000
		end select
	    use
	    end when
	end if
	!
	!	implementation note: sometimes a file gets resaved with no modifications. This means that the file stamp
	!	will be much more current than the most recent modification. For this reason, do not use the "/before"
	!	parameter.
	!
	cmd$ = "$dir/nohead/notrail "+ filter$ +".BAS;"				! get a directory of BASIC files	&
		+"/out="+ k_program +".scratch"					!					&
		+"/since="+ vdate1$						!					&
!~~~		+"/before="+ vdate2$						x
	rc% = lib$spawn(cmd$)							! let DCL execute this command
	print cmd$
	if ((rc% and 7%) <> 1%) then
	    print "-e- lib$spawn error: "+ str$(rc%)
	    goto sortie
	end if
	!
	!	now read the directory listing file (to see if we've found any files to process)
	!
	when error in
	    open k_program +".scratch" for input as #1, recordsize 1024		! open file list
	    count% = 0
	    while 1
		linput #1, junk$						! display the listed file names
		count% = count% + 1
		print #3, format$(count%,"#### ")+junk$
	    next
	use
	end when
	if count% = 0 then
	    print "-e- no files were detected using your search criteria"
	    goto sortie
	end if
	!
	!	now read the directory listing file (again, to dump the filenames into out output file)
	!
	when error in
	    open k_program +".txt" for output as #3, recordsize 1024		! open output file
	    print "-i- output file: "+ k_program +".txt"			!
	    junk$ = wcsm_dt_stamp
	    print #3, "============================================================"
	    print #3, "Source Code Report "+k_version
	    print #3, "Scope    : "+ idate6a$ +" -> "+ idate6b$
	    print #3, "Generated: "+ left$(junk$,8) +"."+ mid$(junk$,9,6)
	    print #3, "Filter   : "+ filter$
	    print #3, "Note: 'file includes' and 'function includes' are ignored"
	    print #3, "============================================================"
	    print #3, ""
	    print #3, "Files considered for processing:"
	    reset #1								!
	    count% = 0
	    while 1
		linput #1, fs1$							! read a file name
		count% = count% + 1
		print #3, format$(count%,"#### ")+fs1$
	    next
	use
	end when
	print #3, ""
	!
	!	now read the directory listing file (again, to process the associated file's contents)
	!
	when error in
	    reset #1
	    while 1
		linput #1, fs1$							! read a file name
		gosub process_file1
	    next
	use
	end when
	close 1,2,3
	goto sortie								!					***--->>>
	!
	!============================================================
	!	process file #1
	!============================================================
	!
	process_file1:
	if debug_flag% = 1 then							! in debug mode, print report header now
	    print #3, "======================================================================"
	    print #3, "file: ";fs1$
	end if
	!
	comments_start% = 0
	in_range%	= 0
	insert%		= 0
	when error in
	    open fs1$ for input as #2, recordsize 1024				! open source code file
	    while 1
		linput #2, ip$							! read a line
 		print #3,"debug-src: ";ip$	if debug_flag% = 1		!
		junk$ = ip$							! make a copy
		junk$ = edit$(junk$,32+16+8)					! upcase, compress, no leading spaces
		!
		select left$(junk$,1)						!
		    case ""							! eg. blank lines
			iterate							!
		    case "%"							! eg. %LET
			iterate							!
		end select							!
		!
		select left$(junk$,7)						!
		    case "DECLARE"						! eg. declare string constant k_version = "
			iterate							!
		end select							!
		!
		select left$(junk$,6)						!
		    case "OPTION"						! eg. OPTION TYPE=EXPLICIT
			iterate							!
		end select							!
		!
		select left$(junk$,3)						!
		    case "SET"							! eg. SET NO PROMPT
			iterate							!
		end select							!
		!
		if left$(junk$,1) <> "!" then					! if this is not a comment start line
		    if comments_start% = 0 then					! if we haven't found our first comment
			iterate							! then ignore this line
		    else							! if we have found our first comment
			goto exit_process_file1					! then exit cuz we're beyond the program header
		    end if							!
		else
		    comments_start% = 1						!
		end if								!
		!
		!	scan the line for words that look like 6 (or 8) character dates
		!
		j% = pos(junk$," ",1%)						! find next space
		while (j%>0) and (junk$ <> "")
		    !
		    junk_word$ = seg$(junk$, 1%, j%-1)				! extract this word
		    junk$ = right$(junk$, j%+1)					! prep for next pass
		    j% = pos(junk$," ",1%)					! prep for next pass
		    !
		    select len(junk_word$)
			case 6							! if this word is 6 chars long
			    when error in
				junk% = integer(junk_word$)			! preform numeric test
			    use
				junk% = 0					! oops
			    end when
			    iterate if junk% = 0				! not numeric so ignore this word
			    !
			    select junk%					! now convert to longer form integer
				case >= 910101					!
				    junk% = junk% + 19000000			!
				case else					!
				    junk% = junk% + 20000000			!
			    end select
			case 8							! if this word is 8 chars long
			    when error in
				junk% = integer(junk_word$)			! perform numeric test
			    use
				junk% = 0					! oops
			    end when
			    iterate if junk% = 0				! not numeric so ignore this word
			case else
			    iterate						!
		    end select
		    !
		    select junk%						!
			case 19910101 to idate8a%				! below range				bf_100.5
			    iterate						!	so ignore this word
			case idate8a% to idate8b%				! in range
			    in_range% = 1					!	make sure this is set if in range
			    goto store_line_now					!	save this whole line
			case 20170101 to idate8b%				! above range				bf_100.5
			    goto exit_process_file1				!
		    end select
		    !
		next
		!
		select left$(junk$,2)						!
		    case "!=", "!+", "!-", "!-", "!~"				! ignore various forms of line decoration
			if insert% = 0 then					! if we haven't seen a target date yet
			    iterate						! then skip this line
			else							! else
			   goto exit_process_file1 				! quit now
			end if							!
		    case "!"							! (this is not a bug)
			if insert% = 0 then					! if we haven't seen a target date yet
			    iterate						! then skip this line
			else							! else
			   goto exit_process_file1 				! quit now
			end if							!
		end select							!
		!
		store_line_now:
		if in_range% = 1 then						! if we've found a date in range
		    insert% = insert% + 1					! the prep to store this line
		    lines$(insert%) = ip$					! store this line
		end if								!
		!
	    next
	use
	end when
	!
	exit_process_file1:
	if insert% = 0 then
	    print #3, "-e- no data found in the range of: "+ idate6a$ +" to: "+ idate6b$	if debug_flag% = 1
	else
	    if debug_flag% = 0 then						! if not debug mode, print report header now
		print #3, "======================================================================"
		print #3, "file: ";fs1$
	    end if
	    i% = 1
	    while i% <= insert%
		print #3, lines$(i%)
		i% = i% + 1
	    next
	end if
	return
	!
	!	<<< adios >>>
	!
30000	sortie:
	close #1
	when error in
	    while 1
		kill k_program+".scratch"
	    next
	use
	end when
	!
	end
	!====================================================================================================
	!
	!	external functions
	!
31000	%include "[.fun]wcsm_dt_stamp.fun"
	!
	!============================================================
	!	icsis_date to vms_date
	!	in:	031231
	!	out:	31-dec-2003
	!============================================================
31010	function string icsis_date_to_vms_date(string passed_date$)
	declare string constant k_months$ = "JANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC"
	declare string my_day$, my_month$, my_year$, temp_date$,				&
		long   my_day%, my_month%, my_year%, leap%, month_limit%, junk%, handler%
	!
	temp_date$ = passed_date$						! copy original data
	!
	select len(temp_date$)
	    case 6
		select left$(temp_date$,2)
		    case "90" to "99"
			temp_date$ = "19"+ temp_date$
		    case else
			temp_date$ = "20"+ temp_date$
		end select
	    case 8
	    case else
		print "-e- date is wrong length"
		goto exit_function
	end select
	!
	!	extract year
	!
	when error in
	    my_year$ = seg$(temp_date$,1,4)
	    my_year% = integer(my_year$)
	    if my_year% = (my_year% / 4% ) * 4% then
		leap% = 1
	    else
		if my_year% = (my_year% / 400% ) * 400% then
		    leap% = 1
		else
		    if my_year% = (my_year% / 100% ) * 100% then
			leap% = 1
		    end if
		end if
	    end if
	    handler% = 0
	use
	    handler% = err
	end when
	goto function_error_exit if handler% <> 0
	!
	!	extract month
	!
	when error in
	    my_month$ = seg$(temp_date$,5,6)
	    my_month% = integer(my_month$)
	    select my_month%
		case < 1, > 12
		    print "-e- month not legal"
		    goto function_error_exit
		case else
		    my_month$ = mid$(k_months$, ((my_month%-1)*3)+1, 3)		! get name from list
	    end select
	use
	end when
	goto function_error_exit if handler% <> 0
	!
	!	compute month limit
	!
	select my_month%
	    case 9,4,6,11
		month_limit% = 30
	    case 2
		if leap% = 1 then
		    month_limit% = 29
		else
		    month_limit% = 28
		end if
	    case else
		month_limit% = 31
	end select
	!
	!	extract day
	!
	when error in
	    my_day$ = seg$(temp_date$,7,8)
	    my_day% = integer(my_day$)
	    select my_day%
		case < 1, > month_limit%
		    print "-e- day not legal"
		    goto function_error_exit
	    end select
	use
	end when
	goto function_error_exit if handler% <> 0
	!
	icsis_date_to_vms_date = my_day$ +"-"+ my_month$ +"-"+ my_year$
	goto exit_function
	!
	function_error_exit:
	icsis_date_to_vms_date = ""
	!
	exit_function:
	end function
	!
